<template>
  <div class="email-verify verify-center" v-if="isInvalidLink">
    <div class="title d-flex align-items-center">{{ $t('auth.reset_password.title') }}</div>

    <div class="content-container">
      <div class="message">{{ $t('auth.reset_password.error_token') }}</div>
      <button type="button" class="button-primary" @click="$router.push('/reset-password')">{{ $t('auth.btn.upper_login') }}</button>
    </div>
  </div>
  <div class="register" v-else>
    <div class="title-wrapper d-flex align-items-center">
      {{ $t('auth.reset_password.title') }}
    </div>

    <div class="content-wrapper">
      <div class="input-wrapper d-flex align-items-center input_group">
        <div class="input_group_prepend">
          <span class="input-group-text"><i class="iconmo-password"></i></span>
        </div>
        <input class="form-control w-100 input_form" @keyup.enter="resetPassword"
               v-validate="'required|min:6|max:128|regex:^(?=.*[a-z])(?=.*[A-Z])(?=.*\\d).+$|no_space|confirmed:password_confirmation'"
               data-vv-validate-on="none" @focus="resetError" :placeholder="$t('auth.placeholder.password')" v-model="user.password"
               v-tooltip="$t('auth.register.password_tooltip')"
               name="password" type="password">
        <span class="invalid-feedback" v-if="isShowPasswordError">{{ errors.first('password') }}</span>
      </div>

      <div class="input-wrapper d-flex align-items-center input_group">
        <div class="input_group_prepend">
          <span class="input-group-text"><i class="iconmo-password"></i></span>
        </div>
        <input class="form-control w-100 input_form" data-vv-as="password confirmation" @keyup.enter="resetPassword"
               data-vv-validate-on="none" ref="password_confirmation" v-validate="'required'" @focus="resetError"
               :placeholder="$t('auth.placeholder.repeat_password')" v-model="user.password_confirmation"
               name="password_confirmation" type="password">
        <span class="invalid-feedback" v-if="isShowPasswordConfirmedError">{{ errors.first('password') }}</span>
        <span class="invalid-feedback" v-if="errors.has('password_confirmation')">{{ errors.first('password_confirmation') }}</span>
      </div>

      <div class="submit-btn text-center">
        <button type="button" @click="resetPassword" class="button-primary">{{ $t('auth.btn.submit') }}</button>
      </div>
    </div>

    <modal v-if="displayModal" @close="modalOff">
      <component v-bind:is="currentModal" :modal-data="modalData"></component>
    </modal>
  </div>
</template>

<script>
import rf from "../../../common/requests/RequestFactory";
import ModalMixin from "../../../common/components/ModalMixin";
import OtpConfirmModal from '../../components/Modal/OtpConfirmModal.vue';
import CheckAuthMixin from "./CheckAuthMixin";
import ResetPasswordErrorModal from './Modal/ResetPasswordErrorModal.vue';

export default {
  data () {
    return {
      user: {
        email: '',
        password: '',
        password_confirmation: '',
        token: this.$route.params.token,
      },
      isInvalidLink: window.isInvalidLink,
    };
  },
  computed: {
    isShowPasswordError () {
      return (
        this.errors.has('password') &&
        !this.errors.firstByRule('password', 'confirmed')
      );
    },
    isShowPasswordConfirmedError () {
      return (!!this.errors.firstByRule('password', 'confirmed') &&
        !this.errors.firstByRule('password_confirmation', 'required')
      );
    }
  },
  mixins: [CheckAuthMixin, ModalMixin],
  methods: {
    resetError () {
      this.errors.clear();
    },
    resetPassword () {
      this.$validator.validateAll()
        .then(() => {
          if (this.errors.any()) {
            return;
          }
          const params = Object.assign({}, this.user);
          rf.getRequest('UserRequest').submitResetPassword(params)
            .then(res => {
              this.resetPasswordSuccess();
            })
            .catch((error) => {
              const errors = error.errors;
              this.errors.clear();
              Object.keys(errors).forEach((key) => {
                this.errors.add({
                  field: key,
                  msg: errors[key][0]
                });
              });
              if (this.errors.has('user')) {
                this.$broadcast('open-modal', ResetPasswordErrorModal, {message: this.errors.first('user')});
                return;
              }
              if (this.errors.has('token')) {
                this.$broadcast('open-modal', ResetPasswordErrorModal, {message: this.errors.first('token')});
                return;
              }
              if (this.errors.has('code')) {
                this.errors.clear();
                this.$broadcast('open-modal', OtpConfirmModal, {
                  callback: this.requestResetPassword,
                  key: `${this._uid}-requestResetPassword`,
                  params: params,
                });
              }
            });
        });
    },
    resetPasswordSuccess () {
      this.$router.push('/login');
      this.$toasted.show(this.$t('auth.reset_password.success_message'), {
        theme: 'bubble',
        position: 'top-right',
        duration: 2000
      });
    },
    requestResetPassword (params) {
      return rf.getRequest('UserRequest').submitResetPassword(params);
    },
  },
  created () {
    const url = new window.URL(window.location.href);
    this.user.email = url.searchParams.get('email');
    this.$on(`${this._uid}-requestResetPassword-confirm-otp-successful`, () => {
      this.resetPasswordSuccess();
    });
  }
};
</script>

<style lang="scss" scoped>
  @import "../../../../sass/mobile/typoVariables";
  .email-verify {
    .title {
      padding: 13rem 0 13rem 12rem;
      background-image: linear-gradient(to bottom, $midnight, $catalina_blue);
      box-shadow: 0 2rem 40rem 0 rgba(0, 0, 0, 0.5);
      color: $white;
      font-size: 18rem;
    }
    .content-container {
      min-height: calc(100vh - 222rem);
      text-align: center;
      background: $bg_primary;
      .message {
        font-size: 14rem;
        padding-top: 32rem;
        text-align: center;
        color: #989898;
      }
      .button-primary {
        width: 122px;
        height: 35px;
        border-radius: 30px;
        background-color: #fa7300;
        font-size: 12rem;
        margin-top: 20rem;

        border: none;
        outline: none;
        color: white;
        cursor: pointer;
        letter-spacing: 1px;
        font-weight: bold;
        &:hover {
          background-color: #da6400;
          color: #fff;
        }
      }
    }
  }
  .register {
    height: calc(100vh - 168rem);
    min-height: 460rem;
    background: $bg_primary;
    font-size: $medium;
    .title-wrapper {
      padding-left: 13rem;
      background-color: #21335b;
      height: 55rem;
      line-height: initial;
      font-size: 18rem;
      color: $white;
    }
    .content-wrapper {
      padding: 10rem $tiny 0 $tiny;
      input:-webkit-autofill,
      input:-webkit-autofill:hover,
      input:-webkit-autofill:focus textarea:-webkit-autofill,
      select:-webkit-autofill,
      select:-webkit-autofill:hover,
      select:-webkit-autofill:focus {
        border: none;
        -webkit-text-fill-color: #000;
        -webkit-box-shadow: 0 0 0px 1000px $white inset;
      }
      .invalid-feedback {
        font-size: 13rem;
        color: red;
        display: block;
        padding-left: $tiny;
      }
      .input-wrapper {
        height: 40rem;
        border-radius: 74rem;
        background-color: $white;
        margin-top: 20rem;
        position: relative;
        input {
          @extend .Medium-14;
          border: 1px solid transparent;
          color: #000;
          outline: none;
          &::placeholder {
            color: #cacaca;
          }
        }
      }
      .submit-btn {
        margin-top: 30rem;
        button {
          outline: none;
          @extend .button-12;
          background: transparent;
          width: 295px;
          height: 32rem;
          border-radius: 30rem !important;
          border: solid 1rem #fa7300;
          color: #fa7300;
          font-weight: bold;
          letter-spacing: 0.5rem;
        }
      }
      .agree-wrapper {
        padding: 19rem 0 12rem 15rem;
        @extend .Medium-14;
        color: #989898;
        position: relative;
        .form-check {
          display: table;
          input {
            display: table-cell;
            vertical-align: middle;
            margin-top: -1rem;
            margin-right: 7rem;
            background-color: #e0e0e0;
          }
          label {
            display: table-cell;
            vertical-align: middle;
          }
        }
        .invalid-feedback {
          top: 38rem;
          font-weight: 400;
        }
      }
      .below-wrapper {
        @extend .Medium-14;
        color: #989898;
        padding: 23rem 0;
        .login-text {
          font-size: $tiny;
          font-weight: bold;
          letter-spacing: 0.5px;
        }
      }
    }
  }

  .input_group {
    background-color: #f0f0f0;
    .input_form {
      border: 1px solid transparent;
      color: #000;
      padding-left: 40rem;
      height: 100%;
      border-radius: 74rem;
      outline: none;
      &:focus {
        box-shadow: 0 0 20px 0 rgba(0, 0, 0, 0.15);
      }
    }
    .input_group_prepend {
      width: 19px;
      display: inline-block;
      margin-left: 16rem;
      line-height: 45rem;
      font-size: 15.5rem;
      position: absolute;
      color: #B0B0B0;
    }
  }

  .button-primary {
    width: 122rem !important;
    height: 35rem !important;
    border-radius: 30rem !important;
    background-color: #fa7300 !important;

    border: none !important;
    outline: none !important;
    color: white !important;
    cursor: pointer !important;
    letter-spacing: 1rem !important;
    font-weight: bold !important;
  }

  .text-link {
    color: #fa7300 !important;
    cursor: pointer !important;
    &:hover {
      text-decoration: underline;
    }
  }
  .invalid-feedback {
    color: red;
    position: absolute;
    text-align: left;
    bottom: -20rem;
    font-size: 10rem;
    left: 5rem;
  }
</style>
